'-----------------------------------------------------
'Ansteuereungsbeispiel fr CC2Net-RAM-Device HS bzw.
'CC2Net-RAM-Interface IC
'CCTools 2002 cctools.hs-control.de (21.08.2002)
'----------------------------------------------------

define cmd byte[2]
define addr word[2]

'RAM-Einsprung-Adressen & Variablen & Konstanten
define READbyte &h11f : define READword &h125
define WRITEbyte &h115 : define WRITEword &h10d
define REDPorts &h101 : define RAMinit &h197
define deselect &b00111110 'fr CC2Net-RAM-Interface IC
'define deselect &b00100110 'fr CC2Net-RAM-Device HS
define control Byte[1] 'Register fr I/O-Ports, CS-Leitungen und Bit17(RAM-Addr)
define bit16 Bit[1]
define CS1 Bit[2] 'Chip-Select: Lo=selected, Hi=deselected
define CS2 Bit[3]
define CS3 Bit[4] 'Bei RAM-Device HS I/O 1
define CS4 Bit[5] 'Bei RAM-Device HS I/O 2
define IO1 Bit[7] 'Bei RAM-Device HS I/O 3
define IO2 Bit[8] 'Bei RAM-Device HS I/O 4


put 12
print "CCTools (c)2002";
print "PCF_LCD";
print "CC2Net-RAM-Dev.";
pause 50
put 12
print "Init...";

gosub RAM_Init
pause 5

put 12
print "Write...";

CS1=0 'RAM 1 selectieren
'ber CS1 bis 4 wird der RAM-Baustein ausgewhlt
'CSx = On od. -1  = Baustein nicht ausgewhlt !
'CSx = Off od. 0  = Baustein ist ausgewhlt !
'Bit16 = On /OF bzw. 0 / -1 = 17tes Adressbit
'der RAM-Bausteine.
'Bit0 bis Bit15 werden mit sys-Aufruf bergeben(addr)


'RAM Beschreiben mit Adresswert
for addr=0 to 512 step 2
 sys WRITEword,not addr,addr
next

put 12
print "Read...";

'514 Werte aus dem RAM-Lesen und an der ser.Schnittstelle
'ausgeben
for addr = 0 to 512 step 2
 print read_word
next

print "Ready";
gosub RAM_deselect
end


'----RAM-Funktionen--------------------------
#RAM_Init
control=&hFE
sys RAMinit,-1,0
return

#READ_byte
sys READbyte,not addr,0
return

#READ_word
sys READword,not addr,0
return

#RAM_Deselect
control=control or deselect
sys WRITEbyte,0,0
return

'Byte schreiben:
'sys WRITEbyte,not addr,Wert

'Word schreiben:
'sys WRITEword,not addr,Wert
'Beim Schreiben von Words mu darauf geachtet
'werden, da nur gerade Adressen angegeben werden
'knnen !
#getPorts 'Portzustnde des Addr.-PCF8574 in Byte "control" speichern
sys &h101
return

#setPorts 'Ports des Addr.-PCF8574 von Byte "control" setzen
goto RAM_Deselect


syscode "rami2c.s19" 'Nur einmal laden, dann auskommentieren !
